VTK: vtkOpenGLHardwareSelector Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkOpenGLHardwareSelector Class Reference

implements the device specific code of vtkOpenGLHardwareSelector. More...

`#include <vtkOpenGLHardwareSelector.h>`

Inheritance diagram for vtkOpenGLHardwareSelector:
[legend]
Collaboration diagram for vtkOpenGLHardwareSelector:
[legend]

## Public Types
typedef vtkHardwareSelector | Superclass
Public Types inherited from vtkHardwareSelector
enum | PassTypes { ACTOR_PASS , COMPOSITE_INDEX_PASS , POINT_ID_LOW24 , POINT_ID_HIGH24 , PROCESS_PASS , CELL_ID_LOW24 , CELL_ID_HIGH24 , MAX_KNOWN_PASS = CELL_ID_HIGH24 , MIN_KNOWN_PASS = ACTOR_PASS }
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkOpenGLHardwareSelector * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | BeginRenderProp () override
| Called by the mapper before and after rendering each prop. More...
void | EndRenderProp () override
| Called by the mapper before and after rendering each prop. More...
void | RenderCompositeIndex (unsigned int index) override
| Called by any vtkMapper or vtkProp subclass to render a composite-index. More...
void | RenderProcessId (unsigned int processid) override
| Called by any vtkMapper or subclass to render process id. More...
void | BeginSelection () override
void | EndSelection () override
Public Member Functions inherited from vtkHardwareSelector
vtkHardwareSelector * | NewInstance () const
vtkSelection * | Select ()
| Perform the selection. More...
int | Render (vtkRenderer *renderer, vtkProp **propArray, int propArrayCount)
| Called by vtkRenderer to render the selection pass. More...
virtual vtkSelection * | GenerateSelection ()
| Generates the vtkSelection from pixel buffers. More...
virtual vtkSelection * | GenerateSelection (unsigned int r[4])
virtual vtkSelection * | GenerateSelection (unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2)
virtual vtkSelection * | GeneratePolygonSelection (int *polygonPoints, vtkIdType count)
| Generates the vtkSelection from pixel buffers. More...
vtkProp * | GetPropFromID (int id)
| returns the prop associated with a ID. More...
std::string | PassTypeToString (PassTypes type)
| Convert a PassTypes enum value to a human readable string. More...
bool | HasHighCellIds ()
bool | HasHighPointIds ()
virtual void | SetRenderer (vtkRenderer *)
| Get/Set the renderer to perform the selection on. More...
virtual vtkRenderer * | GetRenderer ()
| Get/Set the renderer to perform the selection on. More...
virtual void | SetArea (unsigned int, unsigned int, unsigned int, unsigned int)
| Get/Set the area to select as (xmin, ymin, xmax, ymax). More...
virtual void | SetArea (unsigned int[4])
| Get/Set the area to select as (xmin, ymin, xmax, ymax). More...
virtual unsigned int * | GetArea ()
| Get/Set the area to select as (xmin, ymin, xmax, ymax). More...
virtual void | GetArea (unsigned int &, unsigned int &, unsigned int &, unsigned int &)
| Get/Set the area to select as (xmin, ymin, xmax, ymax). More...
virtual void | GetArea (unsigned int[4])
| Get/Set the area to select as (xmin, ymin, xmax, ymax). More...
virtual void | SetFieldAssociation (int)
| Set the field type to select. More...
virtual int | GetFieldAssociation ()
| Set the field type to select. More...
virtual void | SetUseProcessIdFromData (bool)
| In some parallel rendering setups, the process id for elements must be obtained from the data itself, rather than the rendering process' id. More...
virtual bool | GetUseProcessIdFromData ()
| In some parallel rendering setups, the process id for elements must be obtained from the data itself, rather than the rendering process' id. More...
virtual bool | CaptureBuffers ()
| It is possible to use the vtkHardwareSelector for a custom picking. More...
PixelInformation | GetPixelInformation (const unsigned int display_position[2])
| It is possible to use the vtkHardwareSelector for a custom picking. More...
PixelInformation | GetPixelInformation (const unsigned int display_position[2], int maxDist)
| It is possible to use the vtkHardwareSelector for a custom picking. More...
virtual PixelInformation | GetPixelInformation (const unsigned int display_position[2], int maxDist, unsigned int selected_position[2])
| It is possible to use the vtkHardwareSelector for a custom picking. More...
void | ClearBuffers ()
| It is possible to use the vtkHardwareSelector for a custom picking. More...
unsigned char * | GetRawPixelBuffer (int passNo)
| It is possible to use the vtkHardwareSelector for a custom picking. More...
unsigned char * | GetPixelBuffer (int passNo)
| It is possible to use the vtkHardwareSelector for a custom picking. More...
virtual void | UpdateMaximumCellId (vtkIdType attribid)
| Called by any vtkMapper or vtkProp subclass to indicate the maximum cell or point attribute ID it uses. More...
virtual void | UpdateMaximumPointId (vtkIdType attribid)
| Called by any vtkMapper or vtkProp subclass to indicate the maximum cell or point attribute ID it uses. More...
virtual bool | GetActorPassOnly ()
| Get/Set to only do the actor pass. More...
virtual void | SetActorPassOnly (bool)
| Get/Set to only do the actor pass. More...
virtual bool | GetCaptureZValues ()
| Get/Set to capture the zvalue. More...
virtual void | SetCaptureZValues (bool)
| Get/Set to capture the zvalue. More...
virtual void | SetProcessID (int)
| Get/Set the process id. More...
virtual int | GetProcessID ()
| Get/Set the process id. More...
virtual float * | GetPropColorValue ()
| Get/Set the color to be used by the prop when drawing. More...
virtual void | GetPropColorValue (float &, float &, float &)
| Get/Set the color to be used by the prop when drawing. More...
virtual void | GetPropColorValue (float[3])
| Get/Set the color to be used by the prop when drawing. More...
virtual void | SetPropColorValue (float, float, float)
| Get/Set the color to be used by the prop when drawing. More...
virtual void | SetPropColorValue (float[3])
| Get/Set the color to be used by the prop when drawing. More...
void | SetPropColorValue (vtkIdType val)
| Get/Set the color to be used by the prop when drawing. More...
virtual int | GetCurrentPass ()
| Get the current pass number. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkOpenGLHardwareSelector * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkOpenGLHardwareSelector * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkHardwareSelector
static vtkHardwareSelector * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkHardwareSelector * | SafeDownCast (vtkObjectBase *o)
static void | Convert (vtkIdType id, float tcoord[3])
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkOpenGLHardwareSelector ()
| ~vtkOpenGLHardwareSelector () override
void | PreCapturePass (int pass) override
void | PostCapturePass (int pass) override
void | BeginRenderProp (vtkRenderWindow *) override
void | EndRenderProp (vtkRenderWindow *) override
void | SavePixelBuffer (int passNo) override
Protected Member Functions inherited from vtkHardwareSelector
| vtkHardwareSelector ()
| ~vtkHardwareSelector () override
double | GetZValue (int propid)
int | Convert (unsigned long offset, unsigned char *pb)
vtkIdType | GetID (int low24, int mid24, int high16)
virtual bool | PassRequired (int pass)
| Returns is the pass indicated is needed. More...
bool | IsPropHit (int propid)
| After the ACTOR_PASS this return true or false depending upon whether the prop was hit in the ACTOR_PASS. More...
virtual int | GetPropID (int idx, vtkProp *vtkNotUsed(prop))
| Return a unique ID for the prop. More...
virtual void | ProcessPixelBuffers ()
void | BuildPropHitList (unsigned char *rgbData)
int | Convert (unsigned int pos[2], unsigned char *pb)
| `pos` must be relative to the lower-left corner of this->Area. More...
int | Convert (int xx, int yy, unsigned char *pb)
| `pos` must be relative to the lower-left corner of this->Area. More...
void | ReleasePixBuffers ()
| Clears all pixel buffers. More...
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
int | OriginalMultiSample
bool | OriginalBlending
Protected Attributes inherited from vtkHardwareSelector
unsigned char * | PixBuffer [10]
unsigned char * | RawPixBuffer [10]
int | ProcessID
int | CurrentPass
int | Iteration
int | InPropRender
int | PropID
float | PropColorValue [3]
bool | ActorPassOnly
bool | CaptureZValues
vtkRenderer * | Renderer
| Clears all pixel buffers. More...
unsigned int | Area [4]
| Clears all pixel buffers. More...
int | FieldAssociation
| Clears all pixel buffers. More...
bool | UseProcessIdFromData
| Clears all pixel buffers. More...
vtkIdType | MaximumPointId
| Clears all pixel buffers. More...
vtkIdType | MaximumCellId
| Clears all pixel buffers. More...
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

implements the device specific code of vtkOpenGLHardwareSelector.

Implements the device specific code of vtkOpenGLHardwareSelector.

See also
  vtkHardwareSelector

Definition at line 22 of file vtkOpenGLHardwareSelector.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkHardwareSelector vtkOpenGLHardwareSelector::Superclass

Definition at line 26 of file vtkOpenGLHardwareSelector.h.

## Constructor & Destructor Documentation

## ◆ vtkOpenGLHardwareSelector()

vtkOpenGLHardwareSelector::vtkOpenGLHardwareSelector | ( |  | ) |
| protected

## ◆ ~vtkOpenGLHardwareSelector()

vtkOpenGLHardwareSelector::~vtkOpenGLHardwareSelector | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkOpenGLHardwareSelector* vtkOpenGLHardwareSelector::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkOpenGLHardwareSelector::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkOpenGLHardwareSelector::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkHardwareSelector.

Reimplemented in vtkPHardwareSelector.

## ◆ SafeDownCast()

static vtkOpenGLHardwareSelector* vtkOpenGLHardwareSelector::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkOpenGLHardwareSelector::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkHardwareSelector.

Reimplemented in vtkPHardwareSelector.

## ◆ NewInstance()

vtkOpenGLHardwareSelector* vtkOpenGLHardwareSelector::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkOpenGLHardwareSelector::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkHardwareSelector.

Reimplemented in vtkPHardwareSelector.

## ◆ BeginRenderProp() [1/2]

void vtkOpenGLHardwareSelector::BeginRenderProp | ( |  | ) |
| overridevirtual

Called by the mapper before and after rendering each prop.

Reimplemented from vtkHardwareSelector.

## ◆ EndRenderProp() [1/2]

void vtkOpenGLHardwareSelector::EndRenderProp | ( |  | ) |
| overridevirtual

Called by the mapper before and after rendering each prop.

Reimplemented from vtkHardwareSelector.

## ◆ RenderCompositeIndex()

void vtkOpenGLHardwareSelector::RenderCompositeIndex | ( | unsigned int | index | ) |
| overridevirtual

Called by any vtkMapper or vtkProp subclass to render a composite-index.

Currently indices >= 0xffffff are not supported.

Reimplemented from vtkHardwareSelector.

## ◆ RenderProcessId()

void vtkOpenGLHardwareSelector::RenderProcessId | ( | unsigned int | processid | ) |
| overridevirtual

Called by any vtkMapper or subclass to render process id.

This has any effect when this->UseProcessIdFromData is true.

Reimplemented from vtkHardwareSelector.

## ◆ BeginSelection()

void vtkOpenGLHardwareSelector::BeginSelection | ( |  | ) |
| overridevirtual

Reimplemented from vtkHardwareSelector.

## ◆ EndSelection()

void vtkOpenGLHardwareSelector::EndSelection | ( |  | ) |
| overridevirtual

Reimplemented from vtkHardwareSelector.

## ◆ PreCapturePass()

void vtkOpenGLHardwareSelector::PreCapturePass | ( | int | pass | ) |
| overrideprotectedvirtual

Reimplemented from vtkHardwareSelector.

## ◆ PostCapturePass()

void vtkOpenGLHardwareSelector::PostCapturePass | ( | int | pass | ) |
| overrideprotectedvirtual

Reimplemented from vtkHardwareSelector.

## ◆ BeginRenderProp() [2/2]

void vtkOpenGLHardwareSelector::BeginRenderProp | ( | vtkRenderWindow * |  | ) |
| overrideprotectedvirtual

Implements vtkHardwareSelector.

## ◆ EndRenderProp() [2/2]

void vtkOpenGLHardwareSelector::EndRenderProp | ( | vtkRenderWindow * |  | ) |
| overrideprotectedvirtual

Implements vtkHardwareSelector.

## ◆ SavePixelBuffer()

void vtkOpenGLHardwareSelector::SavePixelBuffer | ( | int | passNo | ) |
| overrideprotectedvirtual

Reimplemented from vtkHardwareSelector.

## Member Data Documentation

## ◆ OriginalMultiSample

int vtkOpenGLHardwareSelector::OriginalMultiSample
| protected

Definition at line 66 of file vtkOpenGLHardwareSelector.h.

## ◆ OriginalBlending

bool vtkOpenGLHardwareSelector::OriginalBlending
| protected

Definition at line 67 of file vtkOpenGLHardwareSelector.h.

The documentation for this class was generated from the following file:

- Rendering/OpenGL2/vtkOpenGLHardwareSelector.h